//+------------------------------------------------------------------+
//|                        +   +                                     |
//|                        (---)                                     |
//+------------------------------------------------------------------+

#property copyright "Copyright  2006, Alex Sidd (Executer)"
#property link      "mailto:work_st@mail.ru"

#define MAGIC_BUY 216457
#define MAGIC_SELL 754612

extern int m_CloseTime = 0;
extern int m_OpenTime = 0;
extern int m_IndTime = 0;
extern int m_Type = 0;
extern int m_VolBuy = 50;
extern int m_VolSell = 350;
extern int m_BarBuy = 4;
extern int m_BarSell = 7;
extern int m_Period=2;
extern int m_ShiftBuy = 0;
extern int m_ShiftSell = 0;
extern int m_ForceMode = 1;
extern int m_ForcePrice = 6;

extern int m_DiUp = -99;
extern int m_DiDown = -1;

extern int Slippage = 5;



extern double m_BuyStopLoss = 42;
extern double m_SellStopLoss =42;
extern double m_BuyTakeProfit = 90;
extern double m_SellTakeProfit = 15;
extern double m_BuyTrailingStop = 50;
extern double m_SellTrailingStop = 30;
extern double m_BuyTrailingProf = 15;
extern double m_SellTrailingProf = 3;

extern double DecreaseFactor = 100;
extern double MaximumRisk    = 0.025;
extern double MaximumLots    = 100;

extern bool m_LotOptimize = false;

color clOpenBuy = Blue;
color clCloseBuy = Aqua;
color clOpenSell = Red;
color clCloseSell = Violet;
color clModiBuy = Blue;
color clModiSell = Red;
string Name_Expert = "Executer_v0.01";
int c_time = 15;
int o_time = 15; 
int d_time = 15;
bool UseSound = True;
string NameFileSound = "alert.wav";
double Lots = 0.10;



double GetSizeLot()
  {
   double Lot = Lots;
   
   if(m_LotOptimize==true)
   {
   int cycle;
   int prof = 0;
   
   int    orders = HistoryTotal();     // history orders total
   int    losses = 0;                  // number of losses orders without a break
   int    vinn = 0;
   int i = orders;
//---- select lot size
  Lot = NormalizeDouble(AccountFreeMargin()*MaximumRisk / 100, 1);
  
  if(AccountFreeMargin() <= 10000 && AccountFreeMargin() > 5000) DecreaseFactor = NormalizeDouble(AccountFreeMargin()/100,1);
  if(AccountFreeMargin() <= 5000 && AccountFreeMargin() > 3000) DecreaseFactor = NormalizeDouble(AccountFreeMargin()/200,1);
  
  if(AccountFreeMargin() <= 14) DecreaseFactor = 14;
  if(AccountFreeMargin() > 10000) DecreaseFactor = 60;
 
   if(DecreaseFactor > 0&&orders>DecreaseFactor)
     {
       for(cycle = 1; cycle < DecreaseFactor; cycle++)
         {
           i--;
           if(OrderSelect(i, SELECT_BY_TICKET, MODE_HISTORY) == false) 
             { 
               Print("Error in history!"); 
               break; 
             }
             
           if(OrderCloseTime()>0)
           {
              prof = prof + OrderProfit(); 
              if(OrderProfit() <= 0 ) losses++;
              else vinn++;
           }
         }
         
      if(prof <= 0 ) Lot = 0.1;//Lot - (0.1*losses); //Lot = 0.1;//&& losses > vinn
      
 //     if(prof <=0 && vinn>losses) Lot = Lot - (0.1*losses);
      
      if(prof > 0 && losses > vinn) 
      {
          Lot = Lot + (0.1*NormalizeDouble(vinn/4,0.1));
      }
      if(prof > 0 && losses <= vinn )
      {
          Lot = Lot + (0.1*NormalizeDouble(vinn/2,0.1));
      }
     } 
   if(AccountFreeMargin()<300||Lot < 0.1) Lot = 0.1;
   if(Lot*1275>=AccountFreeMargin()) Lot = NormalizeDouble(AccountFreeMargin()*MaximumRisk / 100, 1);
   if(MaximumLots != 0 && Lot > MaximumLots) Lot = MaximumLots;
   if(DecreaseFactor > orders) Lot = Lots;
   }
   Lot = Lots;
   return(Lot);
  }  
  
int init()
{
   switch (m_CloseTime)
   {
      case 0:
            c_time = 1;
            break;
      case 1:
            c_time = 5;
            break;
      case 2:
            c_time = 15;
            break;
      case 3:
            c_time = 30;
            break;
      case 4:
            c_time = 60;
            break;
      case 5:
            c_time = 240;
            break;
      case 6:
            c_time = 1440;
            break;
      case 7:
            c_time = 10080;
            break;
      case 8:
            c_time = 43200;
            break;
      default:
            c_time = 15;
            break;
   }
   
      switch (m_OpenTime)
   {
      case 0:
            o_time = 1;
            break;
      case 1:
            o_time = 5;
            break;
      case 2:
            o_time = 15;
            break;
      case 3:
            o_time = 30;
            break;
      case 4:
            o_time = 60;
            break;
      case 5:
            o_time = 240;
            break;
      case 6:
            o_time = 1440;
            break;
      case 7:
            o_time = 10080;
            break;
      case 8:
            o_time = 43200;
            break;
      default:
            o_time = 15;
            break;
   }
   
      switch (m_IndTime)
   {
      case 0:
            d_time = 1;
            break;
      case 1:
            d_time = 5;
            break;
      case 2:
            d_time = 15;
            break;
      case 3:
            d_time = 30;
            break;
      case 4:
            d_time = 60;
            break;
      case 5:
            d_time = 240;
            break;
      case 6:
            d_time = 1440;
            break;
      case 7:
            d_time = 10080;
            break;
      case 8:
            d_time = 43200;
            break;
      default:
            d_time = 15;
            break;
   }
   return(0);
}

void deinit() {
   Comment("");
}

bool isHigh()
{
   for(int a = 1; a != m_BarBuy; a++)
   {
      if(iOpen(NULL,5,a)>iClose(NULL,5,a)) return(false);
   }
   return(true);
}

bool isLow()
{
   for(int a = 1; a != m_BarSell; a++)
   {
      if(iOpen(NULL,5,a)<iClose(NULL,5,a)) return(false);
   }
   return(true);
}

bool isStochU(int t)
{
   double a_, b_;
   a_ = iAO(NULL,t,1);
   b_ = iAO(NULL,t,2);
   if(a_>b_)return(true);
   else return(false);
}

bool isStochU2(int t)
{
   double b_;
   b_ = iCustom(NULL,t,"iStochTxt(komposter)",0,1);
   if(b_>0&&b_<1000) return(true);
   else return(false);
}

bool isStochD(int t)
{
   double a_, b_;
   a_ = iAO(NULL,t,1);
   b_ = iAO(NULL,t,2);
   if(a_<b_)return(true);
   else return(false);
}

bool isStochD2(int t)
{
   double b_;
   b_ = iCustom(NULL,t,"iStochTxt(komposter)",1,1);
   if(b_ > 0 && b_ < 1000) return(true);
   else return(false);
}   

bool isBuy()
{

double m_Par_1, m_Par_2;

if(m_Type==0)
{
      m_Par_1=iWPR(NULL,d_time,m_Period,m_ShiftBuy);
      
      if(m_Par_1<m_DiUp) return(true);
      else return(false);
}

if(m_Type==1)
{      
      m_Par_1=iRVI(NULL,d_time,m_Period,MODE_MAIN,m_ShiftBuy);
      m_Par_2=iRVI(NULL,d_time,m_Period,MODE_SIGNAL,m_ShiftBuy);
      
      if(m_Par_1>m_Par_2) return(true);
      else return(false);
}

if(m_Type==2)
{
     m_Par_1=iMFI(NULL,d_time,m_Period,m_ShiftBuy);
     
     if(m_Par_1>(m_DiUp*(-1))) return(true);
     else return(false);
}
if(m_Type==3)
{    
     if(m_ForceMode > 3 || m_ForceMode < 0) m_ForceMode = 1;
     if(m_ForcePrice > 6 || m_ForcePrice < 0) m_ForcePrice = 6;
     
     m_Par_1=iForce(NULL,d_time,m_Period,m_ForceMode,m_ForcePrice,m_ShiftBuy);
     m_Par_2=iForce(NULL,d_time,m_Period,m_ForceMode,m_ForcePrice,m_ShiftBuy+1);
     
     if(m_Par_1>0&&m_Par_2<0) return(true);
     else return(false);
}
}

bool isSell()
{
double m_Par_1, m_Par_2;

if(m_Type==0)
{
      m_Par_1=iWPR(NULL,d_time,m_Period,m_ShiftSell);
      
      if(m_Par_1>m_DiDown) return(true);
      else return(false);
}
if(m_Type==1)
{      
      m_Par_1=iRVI(NULL,d_time,m_Period,MODE_MAIN,m_ShiftSell);
      m_Par_2=iRVI(NULL,d_time,m_Period,MODE_SIGNAL,m_ShiftSell);
      
      if(m_Par_1<m_Par_2) return(true);
      else return(false);
}
if(m_Type==2)
{
     m_Par_1=iMFI(NULL,d_time,m_Period,m_ShiftSell);
     
     if(m_Par_1<(m_DiUp*(-1))) return(true);
     else return(false);
}
if(m_Type==3)
{    
     if(m_ForceMode > 3 || m_ForceMode < 0) m_ForceMode = 1;
     if(m_ForcePrice > 6 || m_ForcePrice < 0) m_ForcePrice = 6;
     
     m_Par_1=iForce(NULL,d_time,m_Period,m_ForceMode,m_ForcePrice,m_ShiftSell);
     m_Par_2=iForce(NULL,d_time,m_Period,m_ForceMode,m_ForcePrice,m_ShiftSell+1);
     
     if(m_Par_1<0&&m_Par_2>0) return(true);
     else return(false);
}
}


int start(){

      if(Bars<100){
      Print("bars less than 100");
      return(0);
   }
   if(m_BuyStopLoss<3){
      Print("StopLoss less than 3");
      return(0);
   }
   if(m_BuyTakeProfit<3){
      Print("TakeProfit less than 3");
      return(0);
   }
   if(m_SellStopLoss<3){
      Print("StopLoss less than 3");
      return(0);
   }
   if(m_SellTakeProfit<3){
      Print("TakeProfit less than 3");
      return(0);
   }
   
      if(AccountFreeMargin()<(1000*Lots)){
      Print("We have no money. Free Margin = ", AccountFreeMargin());
      return(0);
   }
   
   if (!ExistPositionsBuy())
   {

      if ( isBuy()==true&& Volume[1]>Volume[2]&&Volume[1]-Volume[2]>m_VolBuy&&Open[1]-Close[1]<=0&&isStochU2(o_time)==true&&isStochD(c_time)==false){
         OpenBuy();
         return(0);
      }
   }
   
   if(!ExistPositionsSell()){
         if (isSell()==true&& Volume[1]>Volume[2]&&Volume[1]-Volume[2]>m_VolSell&&Close[1]-Open[1]<=0&&isStochD2(o_time)==true&&isStochU(c_time)==false){
         OpenSell();
         return(0);
      }
   }
   
   TrailingPositionsBuy(m_BuyTrailingStop);
   TrailingPositionsSell(m_SellTrailingStop);
   
   if(ExistPositionsBuy())
   {
      if(isStochD(c_time)==true) CloseBuy();
   }
   if(ExistPositionsSell())
   {
      if(isStochU(c_time)==true) CloseSell();
   }
   return (0);
}

bool ExistPositionsBuy() {
	for (int i=0; i<OrdersTotal(); i++) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC_BUY) {
				return(True);
			}
		} 
	} 
	return(false);
}


bool ExistPositionsSell() {
	for (int i=0; i<OrdersTotal(); i++) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC_SELL) {
				return(True);
			}
		} 
	} 
	return(false);
}


void TrailingPositionsBuy(int trailingStop) 
{ 
   for (int i=0; i<OrdersTotal(); i++) 
   { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
      { 
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC_BUY) 
         { 
            if (OrderType()==OP_BUY) 
            { 
               if (Bid-OrderOpenPrice()>trailingStop*Point) 
               { 
                  if (OrderStopLoss()<Bid-trailingStop*Point) 
                  {
                     if (OrderTakeProfit()-Bid<m_BuyTrailingProf*Point&&isHigh()==true)
                     {
                        ModifyStopLoss(Bid-trailingStop*Point,Bid+m_BuyTrailingProf*Point); 
                     }
                     else
                     {
                        ModifyStopLoss(Bid-trailingStop*Point,OrderTakeProfit());
                     }
                  } 
                  else
                  {
                     if (OrderTakeProfit()-Bid<m_BuyTrailingProf*Point&&isHigh()==true)
                     {
                        ModifyStopLoss(OrderStopLoss()+Point,Bid+m_BuyTrailingProf*Point); 
                     }
                  }
               } 
            }  
         } 
      } 
   } 
} 

void TrailingPositionsSell(int trailingStop) 
{ 
   for (int i=0; i<OrdersTotal(); i++) 
   { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
      { 
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC_SELL) 
         { 
            if (OrderType()==OP_SELL) 
            { 
               if (OrderOpenPrice()-Ask>trailingStop*Point) 
               { 
                  if (OrderStopLoss()>Ask+trailingStop*Point || OrderStopLoss()==0)  
                  {
                     if (Ask-OrderTakeProfit()<m_SellTrailingProf*Point&&isLow()==true)
                     {
                        ModifyStopLoss(Ask+trailingStop*Point,Ask-m_SellTrailingProf*Point); 
                     }
                     else
                     {
                        ModifyStopLoss(Ask+trailingStop*Point,OrderTakeProfit());
                     }
                  } 
                  else
                  {
                     if (Ask-OrderTakeProfit()<m_SellTrailingProf*Point&&isLow()==true)
                        ModifyStopLoss(OrderStopLoss()-Point,Ask-m_SellTrailingProf*Point); 
                  }
               }
            } 
         } 
      } 
   } 
} 

void ModifyStopLoss(double ldStopLoss, double IdTakeProfit) { 
   bool fm;
   fm = OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,IdTakeProfit,0,CLR_NONE); 
   if (fm && UseSound) PlaySound(NameFileSound); 
} 

void CloseBuy() { 
   bool fc; 
   fc=OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, clCloseBuy); 
   if (fc && UseSound) PlaySound(NameFileSound); 
} 
void CloseSell() { 
   bool fc; 
   fc=OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, clCloseSell); 
   if (fc && UseSound) PlaySound(NameFileSound); 
} 
void OpenBuy() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 
   ldLot = GetSizeLot(); 
   ldStop = GetStopLossBuy(); 
   ldTake = GetTakeProfitBuy(); 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol(),OP_BUY,ldLot,Ask,Slippage,ldStop,ldTake,lsComm,MAGIC_BUY,0,clOpenBuy); 
   if (UseSound) PlaySound(NameFileSound); 
} 


void OpenSell() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 

   ldLot = GetSizeLot(); 
   ldStop = GetStopLossSell(); 
   ldTake = GetTakeProfitSell(); 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol(),OP_SELL,ldLot,Bid,Slippage,ldStop,ldTake,lsComm,MAGIC_SELL,0,clOpenSell); 
   if (UseSound) PlaySound(NameFileSound); 
} 

string GetCommentForOrder() { 	return(Name_Expert); } 
//double GetSizeLot() { 	return(Lots); } 
double GetStopLossBuy() { 	return (Bid-m_BuyStopLoss*Point);} 
double GetStopLossSell() { 	return(Ask+m_SellStopLoss*Point); } 
double GetTakeProfitBuy() { 	return(Ask+m_BuyTakeProfit*Point); } 
double GetTakeProfitSell() { 	return(Bid-m_SellTakeProfit*Point); } 
return(0);